'use strict';

const moment = require('moment');

module.exports = app => {
  const { STRING, INTEGER, ENUM} = app.Sequelize;
  const AppChannel = app.blockModel.define('app_channel', {
    id: { type: STRING, primaryKey: true },
    app_id: STRING,
    channel_id: STRING,
    alias: STRING,
    url: STRING,
    android_url: STRING,
    ios_url: STRING,
  }, {
    timestamps: false,
    tableName: 'app_channel',
  });

  AppChannel.one = async (data) => {
    const attributes = data.attributes ? data.attributes : {};
    const where = data.where ? data.where : {};
      return await AppChannel.findOne({
          attributes: attributes,
          where : where,
      });
  }


  AppChannel.all = async (data) => {
    const attributes = data.attributes ? data.attributes : {};
    const where = data.where ? data.where : {};
    return await AppChannel.findAll({
        attributes: attributes,
        where : where,
    });
  }

  AppChannel.list = async (data = {}) => {
    const limit = data.limit ? data.limit : 10;
    const page = data.page ? data.page : 1;
    const order = data.order ? data.order : [];
    const attributes = data.attributes ? data.attributes : {};
    const where = data.where ? data.where : {};
    const condition = {
      offset: (page - 1) * limit,
      limit,
      where: where,
      order: order,
      attributes: attributes,
    };
    const { count, rows } =  await AppChannel.findAndCountAll(condition);
    return { page, count, rows };
  }

  AppChannel.add = async (data) => {
    try {
      //返回promise对象实力 instance 
      const res = await AppChannel.create(data);
      //从promise 实例中中获得需要的id号，id 必须是自增长，而且必须主键，否则返回null
      return res.id;  
    } catch(error) {
      ctx.status = 500;
      throw (error);
    }    
  }

  AppChannel.edit = async (data) => {
    const where = data.where;
    const params = data.params;
    AppChannel.update(params, {
      where: where
    }).catch( e => res.json({status: 500, error: e}));
  }

  return AppChannel;

};
